#include <SFML/Graphics.hpp>
#include <iostream>
#include <sstream>
#include <cstdlib>
#include <ctime>
#include <cstdio>
#include <random>
#include <SFML/Window/Mouse.hpp>
using namespace std;

template <typename T>
string NumberToString ( T Number )
{
    ostringstream ss;
    ss << Number;
    return ss.str();
}

bool rowSwipeleft(int B[7][7],int row , int grid , int* scoreptr);//inputs a 2-D gamearray and row index and performs swipe left on the given row
bool Swipeleft(int B[7][7], int grid , int* scoreptr );//swipes left the whole array as per the game rules

bool rowSwiperight(int B[7][7],int row ,int grid , int* scoreptr );//inputs a 2-D gamearray and row index and performs swipe right on the given row
bool Swiperight(int B[7][7], int grid , int* scoreptr);//takes game array as input and performs right swipe on it assuming that it contains only powers of 2

bool colSwipeup(int B[7][7],int col , int grid , int* scoreptr);//inputs a 2-D gamearray and column index and performs swipe up on the given column
bool Swipeup(int B[7][7], int grid , int* scoreptr);//swipes up the whole array as per the game rules

bool colSwipedown(int B[7][7],int col , int grid , int* scoreptr);//inputs a 2-D gamearray and column index and performs swipe down on the given column
bool Swipedown(int B[7][7] , int grid , int* scoreptr);//swipes down the whole array as per the game rules

bool convirnums(int a, int b);//shows whether a and b consecutive virahanka numbers or not

bool virrowSwipeleft(int B[7][7],int row , int grid , int* scoreptr);//inputs a 2-D gamearray and row index and performs swipe left on the given row according to the rules of virahanka 2048
bool virSwipeleft(int B[7][7], int grid , int* scoreptr );//swipes left the whole array as per the game rules

bool virrowSwiperight(int B[7][7],int row ,int grid , int* scoreptr );//inputs a 2-D gamearray and row index and performs swipe right on the given row  according to the rules of virahanka 2048
bool virSwiperight(int B[7][7], int grid , int* scoreptr);//takes game array as input and performs right swipe on it assuming that it contains only powers of 2

bool vircolSwipeup(int B[7][7],int col , int grid , int* scoreptr);//inputs a 2-D gamearray and column index and performs swipe up on the given column according to the rules of virahanka 2048
bool virSwipeup(int B[7][7], int grid , int* scoreptr);//swipes up the whole array as per the game rules

bool vircolSwipedown(int B[7][7],int col , int grid , int* scoreptr);//inputs a 2-D gamearray and column index and performs swipe down on the given column according to the rules of virahanka 2048
bool virSwipedown(int B[7][7] , int grid , int* scoreptr);//swipes down the whole array as per the game rules


bool downflagfunc(int arr[7][7],int htile);// gives whether on performing swipe down will result in addtion of tiles . used in function playby algo3

bool playbyalgo3(int mainarr[7][7] , int* scoreptr , int* htileptr , int& last);//this function decides which of the four swipe would be best in order to creat highscores

int getMovesLeft(int Gamearray[7][7], int grid ); // this function gives the number of valid moves left.

int emptyCells(int Gamearray[7][7], int grid ); // Gives the numbers of empty cells in effective grid.

bool isGameOver(int Gamearray[7][7], int grid); // returns a boolean value corresponding to end of game.

void reset(int &score,int &highScore,bool &showGameOver,int Gamearray[7][7], int grid,char gamemode,int Count); // logs the highScore and re-initialises the game array

void renderGscreen(int Gamearray[7][7], int grid,sf::RenderWindow &window,bool showGameOver); // Sets all properties of objects and draws them

void survival(int Gamearray[7][7]);

int a, b ,Count,random, randomnum,grid=4,i,j;
int score = 0;
int highScore = 0;
int htile=2;
int last=-1;
sf::Texture logo;
sf::Sprite lsprite;
map<int, sf::Color>numberColours;
char gamemode='C',ctheme='B';
bool returnval;
char response;
bool showGameOver = false;
sf::Color windowBGColourB(133, 214, 255, 255);
sf::Color windowBGColourR(250, 10, 40, 255);
sf::Color windowBGColourG(10, 249, 35, 255);
default_random_engine generator;
bernoulli_distribution distribution1(0.8);


int main()
{

    // Define colors for the cells based on their value
    numberColours[0] = sf::Color(37, 179, 250, 255);
    numberColours[1] = sf::Color(80, 76, 67, 255);
    numberColours[2] = sf::Color(238, 248, 218, 255);
    numberColours[4] = sf::Color(237, 254, 200, 255);
    numberColours[8] = sf::Color(242, 177, 121, 255);
    numberColours[16] = sf::Color(245, 149, 99, 255);
    numberColours[32] = sf::Color(246, 124, 95, 255);
    numberColours[64] = sf::Color(246, 94, 59, 255);
    numberColours[128] = sf::Color(237, 207, 114, 255);
    numberColours[256] = sf::Color(237, 204, 97, 255);
    numberColours[512] = sf::Color(237, 200, 80, 255);
    numberColours[1024] = sf::Color(237, 197, 63, 255);
    numberColours[2048] = sf::Color(237, 194, 46, 255);


    sf::Color windowBGColourB(135, 215, 255, 210);
    int Gamearray[7][7];
//initializing game array
    for(a=0; a<7; a++)
    {
        for(b=0; b<7; b++)
        {
            Gamearray[a][b]=0;
        }
    }


    srand(time(NULL));//provides seed)(time) for the random number generator rand()
    Count=0;

    sf::Font font;
    if(!font.loadFromFile("ClearSans-Bold.ttf"))
    {
        return -1; // error...
    }

    sf::Texture image1,image2,image3,image4;
    if(image1.loadFromFile("images/welcome.jpg") != true)//loading different images required
    {
        return -1;
    }

    if(image2.loadFromFile("images/options.jpg") != true)
    {
        return -1;
    }
    if(image3.loadFromFile("images/instructions.jpg") != true)
    {
        return -1;
    }

    if(image4.loadFromFile("images/select.jpg") != true)
    {
        return -1;
    }
    sf::Sprite sprite1(image4);
    sf::Sprite sprite2(image2);
    sf::Sprite sprite3(image3);

    sf::RenderWindow Mwindow(sf::VideoMode(400,500), "Ultimate 2048",sf::Style::Close|sf::Style::Titlebar);//creation of first window
    int menu=-1;


    {
        while (Mwindow.isOpen())
        {
            Mwindow.draw(sprite1);
            Mwindow.display();

            sf::Event event;

            while(Mwindow.pollEvent(event)) // checking mouse clicks to navigate through menu window
            {
                if (event.type == sf::Event::Closed)
                {
                    Mwindow.close();
                    return 0;
                }

                sf::Vector2i locpos = sf::Mouse::getPosition(Mwindow);
                if(menu==-1){
                 if (sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos.x>66&&locpos.x<331&&locpos.y>193&&locpos.y<221){response='y';Mwindow.close();}
               if (sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos.x>55&&locpos.x<344&&locpos.y>355&&locpos.y<384){response='n';sprite1.setTexture(image1);
                        menu=0;}
                        if (sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos.x>22&&locpos.x<375&&locpos.y>432&&locpos.y<460){response='v';Mwindow.close();
                       }
                }

                if(menu==0)
                {
                    if (sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos.x>146&&locpos.x<241&&locpos.y>228&&locpos.y<258)
                    {
                        grid=4;
                        gamemode='C';
                        Mwindow.close();
                    }
                    if (sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos.x>50&&locpos.x<353&&locpos.y>310&&locpos.y<341)
                    {
                        sprite1.setTexture(image2);
                        menu=1;
                    }
                    if (sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos.x>58&&locpos.x<343&&locpos.y>390&&locpos.y<419)
                    {
                        sprite1.setTexture(image3);
                        menu=2;
                    }
                }

                sf::Vector2i locpos1 = sf::Mouse::getPosition(Mwindow);
                if(menu==1)
                {
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>60&&locpos1.x<119&&locpos1.y>158&&locpos1.y<188)
                    {
                        grid=4;
                        Mwindow.close();
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>134&&locpos1.x<194&&locpos1.y>158&&locpos1.y<188)
                    {
                        grid=5;
                        Mwindow.close();
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>211&&locpos1.x<267&&locpos1.y>158&&locpos1.y<188)
                    {
                        grid=6;
                        Mwindow.close();
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>282&&locpos1.x<336&&locpos1.y>158&&locpos1.y<188)
                    {
                        grid=7;
                        Mwindow.close();
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>76&&locpos1.x<128&&locpos1.y>290&&locpos1.y<317)
                    {
                        ctheme='R';
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>144&&locpos1.x<233&&locpos1.y>290&&locpos1.y<317)
                    {
                        ctheme='G';
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>249&&locpos1.x<322&&locpos1.y>290&&locpos1.y<317)
                    {
                        ctheme='B';
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>10&&locpos1.x<128&&locpos1.y>420&&locpos1.y<445)
                    {
                        gamemode='C';
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>144&&locpos1.x<279&&locpos1.y>420&&locpos1.y<445)
                    {
                        gamemode='S';
                    }
                    if(sf::Mouse::isButtonPressed(sf::Mouse::Left)&&locpos1.x>295&&locpos1.x<389&&locpos1.y>420&&locpos1.y<445)
                    {
                        gamemode='X';
                    }
                }
            }
        }
    }

    sf::RenderWindow window(sf::VideoMode(80*grid+80,80*grid+180), "Ultimate 2048",sf::Style::Close);
sf::Thread thread(&survival,Gamearray);
    uniform_int_distribution<int> distribution(0,grid*grid-1);//random number generator used from random header file

    int Xrandom;//placing 7 (which is X for the X-tile mode) at random position in the game array
    if(gamemode=='X')
    {
        Xrandom=distribution(generator);
        Gamearray[Xrandom/4][Xrandom%4] = 7;
        Count=1;
    }

    if(gamemode=='C'||gamemode=='X')
    {
        while(true)
        {
            random=distribution(generator);//placing 2's and 4's at random places to initialize the game
            a=random%grid;
            b=random/grid;
            if(Gamearray[a][b]==0)
            {
                if(random>=4)
                {
                    if(response=='v')Gamearray[a][b]=1;
                    else Gamearray[a][b]=2;
                }
                else
                {
                    if(response=='v')Gamearray[a][b]=2;
                    else Gamearray[a][b]=4;
                }
                Count++;
            }
            if(Count==2)break;
        }
    }
    else{thread.launch();}




    while(window.isOpen())
    {
        sf::Event event1;
        while (window.pollEvent(event1))
        {
            if(sf::Keyboard::isKeyPressed(sf::Keyboard::Return))
            {
                reset(score,highScore,showGameOver,Gamearray,grid,gamemode,Count);
            }
            if (event1.type == sf::Event::Closed)
            {
                window.close();
                return 0;
            }
            //take appropriate actions for appropriate events
            if(response=='n'||response=='v')
            {
                if(sf::Keyboard::isKeyPressed(sf::Keyboard::Up))
                {
                    if(response=='n')returnval=Swipeup(Gamearray,grid, &score);
                        else returnval=virSwipeup(Gamearray,grid, &score);
                }
                else
                {
                    if(sf::Keyboard::isKeyPressed(sf::Keyboard::Left))
                    {
                        if(response=='n')returnval=Swipeleft(Gamearray,grid, &score);
                        else returnval=virSwipeleft(Gamearray,grid, &score);
                    }
                    else
                    {
                        if(sf::Keyboard::isKeyPressed(sf::Keyboard::Right))
                        {
                            if(response=='n')returnval=Swiperight(Gamearray,grid, &score);
                        else returnval=virSwiperight(Gamearray,grid, &score);
                        }
                        else
                        {
                            if(sf::Keyboard::isKeyPressed(sf::Keyboard::Down))
                            {
                                if(response=='n')returnval=Swipedown(Gamearray,grid, &score);
                        else returnval=virSwipedown(Gamearray,grid, &score);
                            }
                            else
                            {
                                continue;
                            }
                        }
                    }
                }
            }

            if(response=='y')
            {
                if(sf::Keyboard::isKeyPressed(sf::Keyboard::Comma))
                {
                    returnval=playbyalgo3(Gamearray, &score , &htile,last);
                }

            }

            if(gamemode=='C'||gamemode=='X')
            {
                if(returnval)
                {
                    while(true)
                    {

                        randomnum = distribution(generator);//placing 2 and 4 at random remaining places after the implementation of swipe functions
                        int a=randomnum%4;
                        int b=randomnum/4;

                        if(Gamearray[a][b]==0)
                        {
                            if(randomnum>=4)
                            {
                                if(response=='v')Gamearray[a][b]=1;
                        else Gamearray[a][b]=2;
                            }
                            else
                            {
                                if(response=='v')Gamearray[a][b]=2;
                    else Gamearray[a][b]=4;
                            }
                            break;
                        }
                    }

                }
            }
            showGameOver=isGameOver(Gamearray,grid); // showgameover is set for displaying the restart game message
        }

        renderGscreen(Gamearray,grid,window,showGameOver); // display elements of game screen

        returnval=false;
    }
    return 0;
}


void survival(int Gamearray[7][7]){
sf::Clock Clock;
sf::Time time;
time = sf::seconds(0.0f);
for(int i=0;;i++){

time +=   Clock.getElapsedTime();

      if (time >= sf::seconds(3.0f*(i+1))){



                    random=rand()%16;
                    a=random%grid;
                    b=random/grid;
                    if(Gamearray[a][b]==0)
                    {
                        if(distribution1(generator))
                        {
                            Gamearray[a][b]=2;
                        }
                        else
                        {
                            Gamearray[a][b]=4;
                        }

                    }
                }
            }

      }


int getMovesLeft(int Gamearray[7][7], int grid )
{
    int movesLeft = 0;
    for (int i = 0; i < grid; i++)
    {
        for (int j = 0; j < grid; j++)
        {
            if (Gamearray[i][j] > 0)
            {
                // If it's a valid tile, look for 0's or the same tile surrounding it as valid moves
                if (i + 1 < grid && (Gamearray[i][j] == Gamearray[i+1][j] || Gamearray[i
                                     +1][j] == 0))
                {
                    movesLeft++;
                }
                if (j + 1 < grid && (Gamearray[i][j] == Gamearray[i][j+1] || Gamearray[i][j+1] == 0))
                {
                    movesLeft++;
                }
            }
        }
    }
    return movesLeft;
}

bool rowSwipeleft(int B[7][7],int row, int grid , int* scoreptr)
{

    int i,j,k;
    int A[7];
    for(i=0; i<grid; i++)
    {
        A[i]=B[row][i];
    }
    for(i=0; i<grid;)
    {
        for(j=i; ((A[j]==0)&&(j<grid)); j++) {}
        if(j==grid)
        {
            break;
        }
        for(k=j+1; ((A[k]==0)&&(k<grid)); k++) {}
        if(k==grid)
        {
            A[i]=A[j];
            if(i!=j)
            {
                A[j]=0;
            }
            break;
        }
        if(A[k]==A[j])
        {
            A[i]=2*A[j];
            *scoreptr+=(A[i]);
            A[k]=0;
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
        else
        {
            A[i]=A[j];
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
    }

    for(i=0; i<grid; i++)
    {
        if(A[i]!=B[row][i])
        {
            for(i=0; i<grid; i++)
            {
                B[row][i]=A[i];
            }
            return true;
        }
    }
    return false;
}
// makes changes to a row of game array corresponding to left swipe and
//returns true if any changes are made and false otherwise


// makes changes to a row of game array corresponding to left swipe and
//returns true if any changes are made and false otherwise

bool Swipeleft(int B[7][7] , int grid , int* scoreptr)
{
//takes game array as input and performs left swipe on it assuming that it contains only powers of 2
    int i;
    bool flag1,flag2;
    flag2=false;
    for(i=0; i<grid; i++)
    {
        flag1=rowSwipeleft(B,i,grid,scoreptr);
        if(flag1==true)
        {
            flag2=true;
        }
    }

    return flag2;
}


bool rowSwiperight(int B[7][7],int row, int grid , int* scoreptr)
{

    int i,j,k;
    int A[7];
    for(i=0; i<grid; i++)
    {
        A[i]=B[row][grid-i-1];
    }
    for(i=0; i<grid;)
    {
        for(j=i; (A[j]==0)&&(j<grid); j++) {}
        if(j==grid)
        {
            break;
        }
        for(k=j+1; (A[k]==0)&&(k<grid); k++) {}
        if(k==grid)
        {
            A[i]=A[j];
            if(i!=j)
            {
                A[j]=0;
            }
            break;
        }
        if(A[k]==A[j])
        {
            A[i]=2*A[j];
            *scoreptr+=(A[i]);
            A[k]=0;
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
        else
        {
            A[i]=A[j];
            if(j!=i)
            {
                A[j]=0;
            }

            i=i+1;
        }
    }
    for(i=0; i<grid; i++)
    {
        if(A[i]!=B[row][grid-i-1])
        {
            for(i=0; i<grid; i++)
            {
                B[row][grid-i-1]=A[i];
            }
            return true;
        }
    }
    return false;
}
// makes changes to a row of game array corresponding to right swipe and
//returns true if any changes are made and false otherwise




bool Swiperight(int B[7][7] , int grid , int* scoreptr) //takes game array as input and performs right swipe on it assuming that it contains only powers of 2
{
    int i;
    bool flag1,flag2;
    flag2=false;
    for(i=0; i<grid; i++)
    {
        flag1=rowSwiperight(B,i,grid,scoreptr);
        if(flag1==true)
        {
            flag2=true;
        }
    }

    return flag2;
}


bool colSwipeup(int B[7][7],int col, int grid , int* scoreptr)
{

    int i,j,k;
    int A[7];
    for(i=0; i<grid; i++)
    {
        A[i]=B[i][col];
    }
    for(i=0; i<grid;)
    {
        for(j=i; (A[j]==0)&&(j<grid); j++) {}
        if(j==grid)
        {
            break;
        }
        for(k=j+1; (A[k]==0)&&(k<grid); k++) {}
        if(k==grid)
        {
            A[i]=A[j];
            if(i!=j)
            {
                A[j]=0;
            }
            break;
        }
        if(A[k]==A[j])
        {
            A[i]=2*A[j];
            *scoreptr+=(A[i]);
            A[k]=0;
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
        else
        {
            A[i]=A[j];
            if(j!=i)
            {
                A[j]=0;
            }

            i=i+1;
        }
    }
    for(i=0; i<grid; i++)
    {
        if(A[i]!=B[i][col])
        {
            for(i=0; i<grid; i++)
            {
                B[i][col]=A[i];
            }
            return true;
        }
    }
    return false;
}
// makes changes to a row of game array corresponding to swipe up and
//returns true if any changes are made and false otherwise

bool Swipeup(int B[7][7] , int grid , int* scoreptr) //takes game array as input and performs swipe up on it assuming that it contains only powers of 2
{
    int i;
    bool flag1,flag2;
    flag2=false;
    for(i=0; i<grid; i++)
    {
        flag1=colSwipeup(B,i,grid,scoreptr);
        if(flag1==true)
        {
            flag2=true;
        }
    }

    return flag2;
}


bool colSwipedown(int B[7][7],int col, int grid , int* scoreptr)
{

    int i,j,k;
    int A[7];
    for(i=0; i<grid; i++)
    {
        A[i]=B[grid-i-1][col];
    }
    for(i=0; i<grid;)
    {
        for(j=i; (A[j]==0)&&(j<grid); j++) {}
        if(j==grid)
        {
            break;
        }
        for(k=j+1; (A[k]==0)&&(k<grid); k++) {}
        if(k==grid)
        {
            A[i]=A[j];
            if(i!=j)
            {
                A[j]=0;
            }
            break;
        }
        if(A[k]==A[j])
        {
            A[i]=2*A[j];
            *scoreptr+=(A[i]);
            A[k]=0;
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
        else
        {
            A[i]=A[j];
            if(j!=i)
            {
                A[j]=0;
            }

            i=i+1;
        }
    }
    for(i=0; i<grid; i++)
    {
        if(A[i]!=B[grid-i-1][col])
        {
            for(i=0; i<grid; i++)
            {
                B[grid-i-1][col]=A[i];
            }
            return true;
        }
    }
    return false;
}
// makes changes to a row of game array corresponding to swipe down and
//returns true if any changes are made and false otherwise

bool Swipedown(int B[7][7] , int grid , int* scoreptr) //takes game array as input and performs swipe down on it assuming that it contains only powers of 2
{
    int i;
    bool flag1,flag2;
    flag2=false;
    for(i=0; i<grid; i++)
    {
        flag1=colSwipedown(B,i,grid,scoreptr);
        if(flag1==true)
        {
            flag2=true;
        }
    }

    return flag2;
}


int emptyCells(int Gamearray[7][7], int grid ) // this function gives the number of valid moves left.
{
    int emp=0;
    for (int i = 0; i < grid; i++)
    {
        for (int j = 0; j < grid; j++)
        {
            if (Gamearray[i][j] == 0)
            {
                emp++;
            }
        }
    }
    return emp;
}

// Check for endgame conditions
bool isGameOver(int Gamearray[7][7], int grid)  // Gives the numbers of empty cells in effective grid.
{
    if (emptyCells(Gamearray,grid)> 0 || getMovesLeft(Gamearray,grid) > 0)
    {
        return false;
    }
    else
    {
        return true;
    }
}

void reset(int &score,int &highScore,bool &showGameOver,int Gamearray[7][7], int grid,char gamemode,int Count)
{
    // Reset score and log if it was a new highscore
    if (score > highScore)
    {
        highScore = score;
    }
    score = 0;

    // Reset grid
    for(int a=0; a<7; a++)
    {
        for(int b=0; b<7; b++)
        {
            Gamearray[a][b]=0;
        }
    }
    Count=0;
    // Turn off the game over text
    showGameOver = false;
    int Xrandom;
    if(gamemode=='X')
    {
        Xrandom=rand()%2;
        Gamearray[Xrandom/4][Xrandom%4] = 7;
        Count=1;
    }

    if(gamemode=='C'||gamemode=='X')
    {
        while(true)
        {
            random=rand()%(grid*grid);
            a=random%grid;
            b=random/grid;
            if(Gamearray[a][b]==0)
            {
                if(random>=4)
                {
                   if(response=='v')Gamearray[a][b]=1;
                    else Gamearray[a][b]=2;
                }
                else
                {
                    if(response=='v')Gamearray[a][b]=2;
                    else Gamearray[a][b]=4;
                }
                Count++;
            }
            if(Count==2)break;
        }
    }
}

void renderGscreen(int Gamearray[7][7], int grid,sf::RenderWindow &window,bool showGameOver)
{


// display elements of gamescreen.


    sf::Font font;
    if(!font.loadFromFile("ClearSans-Bold.ttf"))
    {
    }

//forming content of tiles in the game
    sf::Vector2f textPosition;
    sf::Text text[7][7];
    for(int i=0; i<grid; i++)
    {
        for(int j=0; j<grid; j++)
        {
// select the font
            text[i][j].setFont(font); // font is a sf::Font


// set the string to display
            if(Gamearray[i][j]==7)
            {
                text[i][j].setString("X");
            }
            else
            {
                text[i][j].setString(NumberToString(Gamearray[i][j]));
            }


            if(Gamearray[i][j]==0)
            {
                text[i][j].setString(NumberToString(" "));
            }
// set the character size
            if(Gamearray[i][j]==1)
            {
                text[i][j].setCharacterSize(25);
            }
            else
            {
                text[i][j].setCharacterSize(25); // in pixels, not points!
            }
// set the color
            text[i][j].setColor(sf::Color::Black);

// set the text style
            text[i][j].setStyle(sf::Text::Bold);



        }
    }

    /*if(Gamearray[i][j]==1){
        text[i][j].setPosition(sf::Vector2f(40 + (i*(80+10)), 130+(j*(80+10))));
    }
    else{
    text[i][j].setPosition(sf::Vector2f(45 + (i*(80+10)), 135+(j*(80+10))));
    }
    }}
    //forming contents of tiles over*/


    sf::RectangleShape rect[7][7];
    for(i=0; i<grid; i++)
    {
        for(j=0; j<grid; j++)
        {
            rect[i][j].setSize(sf::Vector2f(80,80));
            if(Gamearray[i][j]>=0)
            {
                rect[i][j].setFillColor(numberColours.find(Gamearray[i][j])->second);
            }
            else
            {
                rect[i][j].setFillColor(sf::Color(80,76,67));
            }
            rect[i][j].setPosition(sf::Vector2f(20 + (j*(80+10)), 120+(i*(80+10))));
        }
    }

    for(i=0; i<grid; i++)
    {
        for(j=0; j<grid; j++)
        {
            textPosition = (rect[i][j].getPosition() + (rect[i][j].getSize() / 2.f));
            textPosition.x -= text[i][j].getGlobalBounds().width / 2.f;
            textPosition.y -= (text[i][j].getGlobalBounds().height + 10.f) / 2.f;
            text[i][j].setPosition(textPosition);
        }
    }

    if(logo.loadFromFile("images/2048logo.png") != true)
    {
        ;
    }
    lsprite.setTexture(logo);

    switch(ctheme)
    {
    case 'R':
        window.clear(windowBGColourR);
        break;
    case 'G':
        window.clear(windowBGColourG);
        break;
    default :
        window.clear(windowBGColourB);
        break;

    }

    lsprite.setPosition(sf::Vector2f(80*grid+80-220,25));
    window.draw(lsprite);



    for(i=0; i<grid; i++)
    {
        for(j=0; j<grid; j++)
        {
            window.draw(rect[i][j]);
        }

    }

    for(i=0; i<grid; i++)
    {
        for(j=0; j<grid; j++)
        {
            window.draw(text[i][j]);
        }

    }

    sf::Text scoreText(NumberToString(score), font, 30);
    sf::Text scoreDecoratorText("", font, 20);

    scoreText.setStyle(sf::Text::Bold);
    // render the score info
    scoreText.setString(NumberToString(score));
    scoreText.setPosition(sf::Vector2f(85, 25));
    window.draw(scoreText);
    scoreDecoratorText.setString("Score:");
    scoreDecoratorText.setPosition(sf::Vector2f(25, 35));
    window.draw(scoreDecoratorText);
    scoreDecoratorText.setString("Highscore: " + NumberToString(highScore));
    scoreDecoratorText.setPosition(sf::Vector2f(scoreDecoratorText.getPosition().x, 72));
    window.draw(scoreDecoratorText);




    sf::Text gameOverText("Game Over!", font, 50);
    sf::RectangleShape gameOverBackground;
    gameOverBackground.setSize(sf::Vector2f(80*grid+80,80*grid+180));
    gameOverBackground.setFillColor(sf::Color(250, 248, 239, 175));
    gameOverBackground.setPosition(sf::Vector2f(0, 0));
    gameOverText.setStyle(sf::Text::Bold);
    gameOverText.setColor(sf::Color::Black);
    gameOverText.setPosition(sf::Vector2f(60, 265));

    if (showGameOver)
    {
        window.draw(gameOverBackground);
        window.draw(gameOverText);
        scoreDecoratorText.setString("Hit enter to restart");
        scoreDecoratorText.setColor(sf::Color::Black);
        scoreDecoratorText.setPosition(sf::Vector2f(gameOverText.getPosition().x + 75, gameOverText.getPosition().y + gameOverText.getLocalBounds().height + 10*2));
        window.draw(scoreDecoratorText);
    }

    window.display();
}

bool downflagfunc(int arr[7][7],int htile)//gives true if tiles add when we perform swipedown
{
    int i;
    bool result=false;
    for(i=0; i<4; i++)
    {
        if(arr[3][i]==arr[2][i])
        {
            result=true;
        }
    }

    for(i=0; i<4; i++)
    {
        if((arr[1][i]==arr[2][i])&&(arr[1][i]>=8))
        {
            result=true;
        }
    }

    if(htile>=512)
    {
        for(i=0; i<4; i++)
        {
            if((arr[1][i]==arr[2][i])||(arr[0][i]==arr[1][i]))
            {
                result=true;
            }
        }
    }
    if((arr[3][0]==0)||(arr[3][1]==1))result=false;
    return result;

}



bool playbyalgo3(int mainarr[7][7] , int* scoreptr , int* htileptr , int& last)
{

    int temparr[7][7];//temporary array used to do calculations
    int i,scoreR,scoreL;
    bool result;
    bool downflag=false;//true if tiles add on performing swipedown
    bool downflagL=false;//true if tiles add on performing swipedown after performing swipe left
    bool downflagR=false;//true if tiles add on performing swipedown after performing sipwe right
    bool spflag=true;//this flag shows whether last row is affected or not by performing swipe left and right
    bool spflag2=true;//this flag shows whether last row is in decreasing order or not
    bool spflag3=true;//shows whether 3rd row is pack or not when last is packed
    bool lasflag=false;//true if gamearray becomes favourable (becomes activate only when hightile is >=1024)

    int temp;
        for(int i=0; i<4; i++)
    {
        for(int j=0 ; j<4 ; j++)
        {
            temparr[i][j]=mainarr[i][j];//equating temparray and mainarray
        }
    }


    for( i=0; i<4; i++)//evaluating spflag
    {
        if(mainarr[3][i]==0)
        {
            spflag=false;
        }
    }

    for(i=0; i<3; i++)
    {
        if(mainarr[3][i]==mainarr[3][i+1])
        {
            spflag=false;
        }
    }

    for( i=0; i<4; i++)
    {
        if(mainarr[2][i]==0)
        {
            spflag3=false;//evaluating spflag3
        }
    }

    for(i=0; i<3; i++)
    {
        if(mainarr[2][i]==mainarr[2][i+1])
        {
            spflag3=false;
        }
    }

    for(i=0; i<3; i++)
    {
        if(mainarr[3][i]<mainarr[3][i+1])
        {
            spflag2=false;//evaluating spflag2
        }
    }

    if(!spflag)
    {
        spflag2=false;
    }

    downflag=downflagfunc(mainarr,*htileptr);//evaluate downflag

    if((*htileptr>=1024))
    {
        lasflag=true;
    }

    bool flag[4];//flag[i] denote the return value of swipe functions
    for(int i=0; i<4 ; i++)
    {
        flag[i]=false;
    }

    int newscore[4];//increase in score if we perform swipe functions
    for(int i=0; i<4 ; i++)
    {
        newscore[i]=0;
    }


    {
        temp=*scoreptr;
        flag[0]=Swipeleft(temparr,4,scoreptr);
        newscore[0]=(*scoreptr)-temp;//evaluating flag[0] and newscore[0]


        if(spflag3)
        {
            for(i=0; i<4; i++)
            {
                if((temparr[2][i]>=16)&&((temparr[2][i]==temparr[1][i])||(temparr[2][i]==temparr[3][i])))
                {
                    lasflag=false;//conditions on lasflag
                }
            }
        }
        if(flag[0])
        {
            downflagL=downflagfunc(temparr,*htileptr);//conditions on downflagL
        }

        if(((mainarr[3][1]==2)||(mainarr[3][1]==4))&&(temparr[3][1]>mainarr[3][1]))
        {
            downflagL=true;
        }

        if(((mainarr[3][2]==2)||(mainarr[3][2]==4))&&(temparr[3][2]>mainarr[3][2]))
        {
            downflagL=true;
        }

        Swipedown(temparr,4,scoreptr);
        scoreL=*scoreptr-temp;
        *scoreptr=temp;

        if(((mainarr[3][1]==2)||(mainarr[3][1]==4))&&(temparr[3][1]>mainarr[3][1]))
        {
            downflagL=true;
        }

        if(((mainarr[3][1]==2)||(mainarr[3][1]==4))&&(temparr[3][1]>mainarr[3][1]))
        {
            downflagL=true;
        }


        for(int i=0; i<4; i++)
        {
            for(int j=0 ; j<4 ; j++)
            {
                temparr[i][j]=mainarr[i][j];//re equating temparray with mainarray
            }
        }


    }

    {
        temp=*scoreptr;
        flag[1]=Swiperight(temparr,4,scoreptr);
        newscore[1]=(*scoreptr)-temp;



        if(flag[1])
        {
            downflagR=downflagfunc(temparr,*htileptr);
            if(spflag2&&(mainarr[3][3]>=mainarr[2][3]))
            {
                downflagR=true;
            }
        }

        if(((mainarr[3][1]==2)||(mainarr[3][1]==4))&&(temparr[3][1]>mainarr[3][1]))
        {
            downflagR=true;
        }

        if(((mainarr[2][1]==2)||(mainarr[2][1]==4))&&(temparr[2][1]>mainarr[2][1]))
        {
            downflagR=true;
        }

        if(((mainarr[3][2]==2)||(mainarr[3][2]==4))&&(temparr[3][2]>mainarr[3][2]))
        {
            downflagR=true;
        }

        Swipedown(temparr,4,scoreptr);
        scoreR=*scoreptr-temp;
        *scoreptr=temp;

        if(((mainarr[3][1]==2)||(mainarr[3][1]==4))&&(temparr[3][1]>mainarr[3][1]))
        {
            downflagR=true;
        }

        if(((mainarr[2][1]==2)||(mainarr[2][1]==4))&&(temparr[2][1]>mainarr[2][1]))
        {
            downflagR=true;
        }

        if(((mainarr[3][1]==2)||(mainarr[3][1]==4))&&(temparr[3][1]>mainarr[3][1]))
        {
            downflagR=true;
        }

        for(int i=0; i<4; i++)
        {
            for(int j=0 ; j<4 ; j++)
            {
                temparr[i][j]=mainarr[i][j];
            }
        }

    }

    {
        temp=*scoreptr;
        flag[2]=Swipeup(temparr,4,scoreptr);
        newscore[2]=(*scoreptr)-temp;
        *scoreptr=temp;




        for(int i=0; i<4; i++)
        {
            for(int j=0 ; j<4 ; j++)
            {
                temparr[i][j]=mainarr[i][j];
            }
        }

    }

    {

        temp=*scoreptr;
        flag[3]=Swipedown(temparr,4,scoreptr);
        newscore[3]=(*scoreptr)-temp;
        *scoreptr=temp;



        if(mainarr[3][3]<temparr[3][3])
        {
            downflag=true;
        }


        for(int i=0; i<4; i++)
        {
            for(int j=0 ; j<4 ; j++)
            {
                temparr[i][j]=mainarr[i][j];
            }
        }

    }


    if(*htileptr<1024)
    {
        lasflag=false;
    }



    if((!flag[0])&&(!flag[1])&&(!flag[2])&&(!flag[3]))
    {
        return false;
    }

    if((last==2)&&flag[3])//make a move depending on the situation
    {
        result=Swipedown(mainarr,4,scoreptr);//last represents the last move(up,down,left or right)
        last=3;
    }
    else
    {
        if((last==1)&&flag[0])
        {
            result=Swipeleft(mainarr,4,scoreptr);
            last=0;
        }
        else
        {
            if(((downflag)||(last==7)||(last==9))&&flag[3])
            {
                result=Swipedown(mainarr,4,scoreptr);
                last=3;
            }
            else
            {

                if(downflagR&&spflag&&flag[1]&&((scoreR>scoreL)||lasflag))
                {
                    result=Swiperight(mainarr,4,scoreptr);
                    last=7;
                }

                else
                {

                    if(downflagL&&flag[0])
                    {
                        result=Swipeleft(mainarr,4,scoreptr);

                        last=0;
                    }

                    else
                    {
                        if(flag[0]&&flag[3])
                        {
                            if(newscore[0]>newscore[3])
                            {
                                result=Swipedown(mainarr,4,scoreptr);
                                last=3;
                            }
                            else
                            {
                                result=Swipeleft(mainarr,4,scoreptr);
                                last=0;
                            }
                        }
                        else
                        {
                            if(flag[0])
                            {
                                result=Swipeleft(mainarr,4,scoreptr);
                                last=0;
                            }
                            else
                            {
                                if(flag[3])
                                {
                                    result=Swipedown(mainarr,4,scoreptr);
                                    last=3;
                                }
                                else
                                {
                                    if(flag[1])
                                    {
                                        result=Swiperight(mainarr,4,scoreptr);
                                        last=1;
                                    }
                                    else
                                    {
                                        result=Swipeup(mainarr,4,scoreptr);
                                        last=2;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    int max;
    max = mainarr[0][0];
    for(int i=0; i<4; i++)
    {
        for(int j=0 ; j<4 ; j++)
        {
            if(mainarr[i][j]>max)
            {
                max=mainarr[i][j];//evaluate highest tile in the gamearray
            }
        }
    }

    *htileptr=max;
    return result;
}


bool convirnums(int a, int b){//implementing convirnums
if((a==1)&&(b==1)){
    return true;
}


bool result=false;
bool flag=false;

int i,num;
int num1=1;
int num2=1;

if(b<a){//swaps a and b if b<a
   num=b;
   b=a;
   a=num;
}

while(true){

if(a==num1){
    flag=true;//cheks the virahanka number which is equal to a
}

num=num1;
num1=num1+num2;//num1 is the next virahanka number of num2
num2=num;

cout<<"loop!"<<endl;
cout<<a<<endl<<b<<endl;

if(flag){
    if(b==num1){
        result=true;//checks whether the b is next virahanka number of a or not
        break;
    }
    else{
        break;
    }
}


}

cout<<result<<endl;

return result;

}


bool virrowSwipeleft(int B[7][7],int row, int grid , int* scoreptr)
{

    int i,j,k;
    int A[7];
    for(i=0; i<grid; i++)
    {
        A[i]=B[row][i];
    }
    for(i=0; i<grid;)
    {
        for(j=i; (A[j]==0)&&(j<grid); j++) {}
        if(j==grid)
        {
            break;
        }
        for(k=j+1; (A[k]==0)&&(k<grid); k++) {}
        if(k==grid)
        {
            A[i]=A[j];
            if(i!=j)
            {
                A[j]=0;
            }
            break;
        }
        if(convirnums(A[j],A[k]))
        {
            A[i]=A[j]+A[k];
            *scoreptr+=(A[i]);
            A[k]=0;
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
        else
        {
            A[i]=A[j];
            if(j!=i)
            {
                A[j]=0;
            }

            i=i+1;
        }
    }
    for(i=0; i<grid; i++)
    {
        if(A[i]!=B[row][i])
        {
            for(i=0; i<grid; i++)
            {
                B[row][i]=A[i];
            }
            return true;
        }
    }
    return false;
}
// makes changes to a row of game array corresponding to left swipe(by rules of virahanka 2048) and
//returns true if any changes are made and false otherwise


// makes changes to a row of game array corresponding to left swipe and
//returns true if any changes are made and false otherwise

bool virSwipeleft(int B[7][7] , int grid , int* scoreptr)
{
//takes game array as input and performs left swipe on it assuming that it contains only powers of 2
    int i;
    bool flag1,flag2;
    flag2=false;
    for(i=0; i<grid; i++)
    {
        flag1=virrowSwipeleft(B,i,grid,scoreptr);
        if(flag1==true)
        {
            flag2=true;
        }
    }

    return flag2;
}

bool virrowSwiperight(int B[7][7],int row, int grid , int* scoreptr)
{

    int i,j,k;
    int A[7];
    for(i=0; i<grid; i++)
    {
        A[i]=B[row][3-i];
    }
    for(i=0; i<grid;)
    {
        for(j=i; (A[j]==0)&&(j<grid); j++) {}
        if(j==grid)
        {
            break;
        }
        for(k=j+1; (A[k]==0)&&(k<grid); k++) {}
        if(k==grid)
        {
            A[i]=A[j];
            if(i!=j)
            {
                A[j]=0;
            }
            break;
        }
        if(convirnums(A[j],A[k]))
        {
            A[i]=A[j]+A[k];
            *scoreptr+=(A[i]);
            A[k]=0;
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
        else
        {
            A[i]=A[j];
            if(j!=i)
            {
                A[j]=0;
            }

            i=i+1;
        }
    }
    for(i=0; i<grid; i++)
    {
        if(A[i]!=B[row][3-i])
        {
            for(i=0; i<grid; i++)
            {
                B[row][3-i]=A[i];
            }
            return true;
        }
    }
    return false;
}
// makes changes to a row of game array corresponding to right swipe and
//returns true if any changes are made and false otherwise


// makes changes to a row of game array corresponding to right swipe and
//returns true if any changes are made and false otherwise

bool virSwiperight(int B[7][7] , int grid , int* scoreptr)
{
//takes game array as input and performs right swipe on it assuming that it contains only powers of 2
    int i;
    bool flag1,flag2;
    flag2=false;
    for(i=0; i<grid; i++)
    {
        flag1=virrowSwiperight(B,i,grid,scoreptr);
        if(flag1==true)
        {
            flag2=true;
        }
    }

    return flag2;
}


bool vircolSwipeup(int B[7][7],int col, int grid , int* scoreptr)
{

    int i,j,k;
    int A[7];
    for(i=0; i<grid; i++)
    {
        A[i]=B[i][col];
    }
    for(i=0; i<grid;)
    {
        for(j=i; (A[j]==0)&&(j<grid); j++) {}
        if(j==grid)
        {
            break;
        }
        for(k=j+1; (A[k]==0)&&(k<grid); k++) {}
        if(k==grid)
        {
            A[i]=A[j];
            if(i!=j)
            {
                A[j]=0;
            }
            break;
        }
        if(convirnums(A[j],A[k]))
        {
            A[i]=A[j]+A[k];
            *scoreptr+=(A[i]);
            A[k]=0;
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
        else
        {
            A[i]=A[j];
            if(j!=i)
            {
                A[j]=0;
            }

            i=i+1;
        }
    }
    for(i=0; i<grid; i++)
    {
        if(A[i]!=B[i][col])
        {
            for(i=0; i<grid; i++)
            {
                B[i][col]=A[i];
            }
            return true;
        }
    }
    return false;
}
// makes changes to a row of game array corresponding to swipe up and
//returns true if any changes are made and false otherwise


// makes changes to a row of game array corresponding to swipe up and
//returns true if any changes are made and false otherwise

bool virSwipeup(int B[7][7] , int grid , int* scoreptr)
{
//takes game array as input and performs swipe up on it assuming that it contains only powers of 2
    int i;
    bool flag1,flag2;
    flag2=false;
    for(i=0; i<grid; i++)
    {
        flag1=vircolSwipeup(B,i,grid,scoreptr);
        if(flag1==true)
        {
            flag2=true;
        }
    }

    return flag2;
}


bool vircolSwipedown(int B[7][7],int col, int grid , int* scoreptr)
{

    int i,j,k;
    int A[7];
    for(i=0; i<grid; i++)
    {
        A[i]=B[3-i][col];
    }
    for(i=0; i<grid;)
    {
        for(j=i; (A[j]==0)&&(j<grid); j++) {}
        if(j==grid)
        {
            break;
        }
        for(k=j+1; (A[k]==0)&&(k<grid); k++) {}
        if(k==grid)
        {
            A[i]=A[j];
            if(i!=j)
            {
                A[j]=0;
            }
            break;
        }
        if(convirnums(A[j],A[k]))
        {
            A[i]=A[j]+A[k];
            *scoreptr+=(A[i]);
            A[k]=0;
            if(j!=i)
            {
                A[j]=0;
            }
            i=i+1;
        }
        else
        {
            A[i]=A[j];
            if(j!=i)
            {
                A[j]=0;
            }

            i=i+1;
        }
    }
    for(i=0; i<grid; i++)
    {
        if(A[i]!=B[3-i][col])
        {
            for(i=0; i<grid; i++)
            {
                B[3-i][col]=A[i];
            }
            return true;
        }
    }
    return false;
}
// makes changes to a row of game array corresponding to swipe down and
//returns true if any changes are made and false otherwise


// makes changes to a row of game array corresponding to swipe down and
//returns true if any changes are made and false otherwise

bool virSwipedown(int B[7][7] , int grid , int* scoreptr)
{
//takes game array as input and performs swipe down on it assuming that it contains only powers of 2
    int i;
    bool flag1,flag2;
    flag2=false;
    for(i=0; i<grid; i++)
    {
        flag1=vircolSwipedown(B,i,grid,scoreptr);
        if(flag1==true)
        {
            flag2=true;
        }
    }

    return flag2;
}
